	
	// ========================================================================================
	//							PLUGIN APP
	// ========================================================================================
	
	
	// ----------------------------------------------------------------------------------------
	// Set current menu	
	
	
	(function($){
	
		$.fn.setCurrent = function(classe){
		
			var classe = classe ? classe : 'current';
			$(this).parent().children('.' + classe).removeClass(classe);
			$(this).addClass(classe);
			return this;
			
		};
		
	})(jQuery);
	
	
	// ----------------------------------------------------------------------------------------
	// Remove style inline
	
	
	(function($) {
	
		$.fn.removeStyle = function(style){
			
			var search = new RegExp(style + '[^;]+;?', 'g');
			return this.each(function() {
			
				$(this).attr('style', function(i, style){
					return style.replace(search, '');
				});
				
			});
			
		};
		
	})(jQuery);	
	
	
	// ----------------------------------------------------------------------------------------
	// Rotate
	
	
	(function($) {
	
		$.fn.rotate = function(val, time, easing){
			
			var easing = easing === undefined ? 'linear' : easing;
			
			return this.each(function() {
				
				$(this).animate({borderSpacing: val}, {
					
					step: function(now, fx) {
						$(this).css('-webkit-transform','rotate(' +now + 'deg)');
						$(this).css('-moz-transform','rotate(' +now + 'deg)'); 
						$(this).css('transform','rotate(' + now + 'deg)');  
					},
					duration: time
					
				}, easing);
				
			});
			
		};
		
	})(jQuery);
	
		
	// ----------------------------------------------------------------------------------------
	// Loader
	
	
	(function($){
	
		$.fn.addLoader = function(param){
			
			var settings = $.extend({
				'offset': 		24,
				'loop': 		12,
				'speed': 		80,
				'classe': 		'',
				'delay': 		250
			}, param);
			
			return this.each(function() {
			
				var $elm = $(this),
					$loader = $('<span />').addClass('loader').addClass(settings.classe).css({'background-position': 'left bottom'});
					
				$loader.data('delay', setTimeout(function() {
				
					$elm.prepend($loader);
					
					var position = settings.offset;
					
					$loader.data('animation', setInterval(function() {								
						if (position == (settings.offset * settings.loop)) position = 0;
						$loader.css({'background-position': ' -'+ position +'px' + ' bottom'});
						position = position + settings.offset;									
					}, settings.speed));
				
				}, settings.delay));
				
				$elm.on('disable-loader', function() {
					
					var animation = $loader.data('animation'),
						delay = $loader.data('delay');
					
					clearTimeout(delay);
					clearTimeout(animation);
					
					$loader.fadeOut(180, function() {
						$loader.remove();
					});
			
					$elm.off('disable-loader');
					
				})
			
			});
			
		};
		
	})(jQuery);
		
	
	// ----------------------------------------------------------------------------------------
	// Serialize form
	
		
	(function($){
	
		$.fn.serializeForm = function(){
			
			var array = $(this).serializeArray();
			array = normalize(array);
			
			var object,
				k = 0;
			
			$.each(array, function() {
				
				var	value = this.value,
					arrayName = this.name,
					create = function(i, tmpObject) {
				
						var name = arrayName[i];
							
						if (i == arrayName.length) return value;						
						if (tmpObject == undefined && name !== '') tmpObject = {};
						else if (tmpObject == undefined && name == '') tmpObject = [];
						
						i++;
						
						if (name !== '') tmpObject[name] = create(i, tmpObject[name]);
						else tmpObject.push(create(i, tmpObject[name]));
						
						return tmpObject;
				
					}
				
				object = create(0, object);
							
			});
			
			return object;
			
		};
		
		normalize = function(array) {
			
			for (id in array) {
				
				var value = array[id];
				
				value.name = value.name.replace(/\'\]\[\'/gi, '_;;_');
				value.name = value.name.replace(/\[\'/gi, '_;;_');
				value.name = value.name.replace(/\'\]/gi, '');
				value.name = value.name.replace(/\]\[/gi, '_;;_');
				value.name = value.name.replace(/\[/gi, '_;;_');
				value.name = value.name.replace(/\]/gi, '');
				
				value.name = value.name.split('_;;_');

				array[id] = value;
				
			};
			
			return array;
			
		};
		
	})(jQuery);
	
		
	// ----------------------------------------------------------------------------------------
	// Title auto adapt
	
	
	(function($) {
	
		$.fn.titleAdapt = function(maxFontSize){
			
			var $this = $(this);
			
			$this.wrapInner('<span />');
			
			var $span = $this.find('span'),
				boxWidth = $this.width(),
				titleWidth = $this.data('titleWidth') || $span.width(),
				fontSize = parseFloat($this.css('font-size').replace('px','')),
				newFontSize = Math.floor((boxWidth * fontSize) / titleWidth),
				newFontSize = newFontSize > maxFontSize ? maxFontSize : newFontSize;
			
			$this.css({"font-size" : newFontSize}).data('titleWidth', $span.width());
			
			return this;
			
		};
		
	})(jQuery);	
	
	
	// ----------------------------------------------------------------------------------------
	// Opacity animate
	
	
	(function($) {
	
		$.fn.opacity = function(value, time, callback){
			
			return this.each(function() {
			
				var $this = $(this);
				
				if (!time) $this.css({'opacity' : value});
				else $this.animate({
					'opacity': value
				}, time, callback);
				
			});		
			
		};
		
	})(jQuery);	
	
	
	// ----------------------------------------------------------------------------------------
	// Alert error form
	
	
	(function($) {
	
		$.fn.alertError = function(error){
			
			return this.each(function() {
			
				var $block = $(this),
					$arrowAlert = $('<span />').addClass('arrow'),
					$alert = $block.find('.alert').length ? $() : $('<span />', {text: error.description}).addClass('alert').append($arrowAlert),
					$label = $block.find('.form-label'),
					$input = $block.find('*:[name = "' + error.field + '"]');
				
				$alert.prependTo($label).moveShow(0.9, -10, 200);
				$input.on('focus', function(error) {
					$alert.fadeOut(200, function() {
						$alert.remove();
					});
					$block.removeClass('error');
					$input.off('focus');
				});
				
			});
			
		};
		
	})(jQuery);	
	
	
	// ----------------------------------------------------------------------------------------
	// move show
	
	
	(function($) {
	
		$.fn.moveShow = function(opacity, margin, speed, callback){
			
			return this.each(function() {
			
				var $elm = $(this);
				
				$elm.show().opacity(0).css('margin-top', margin + 'px').animate({
					opacity: opacity,
					marginTop: 0
				}, speed, callback);
				
			});
			
		};
		
	})(jQuery);	
	
	// ----------------------------------------------------------------------------------------
	// move hide
	
	
	(function($) {
	
		$.fn.moveHide = function(margin, speed, remove, callback){
			
			return this.each(function() {
			
				var $elm = $(this);
				
				$elm.animate({
					opacity: 0,
					marginTop: margin
				}, speed, function() {
					if (remove) $elm.remove();
					if ($.isFunction(callback)) callback();
				});
				
			});
			
		};
		
	})(jQuery);	
	
	
	// ----------------------------------------------------------------------------------------
	// animate show
	
	
	(function($) {
	
		$.fn.animateShow = function(fadeSpeed, heightSpeed, callback){
			
			return this.each(function() {
			
				var $elm = $(this),
					height = $elm.height();
				
				$elm.opacity(0).height(0).show().animate({
					height: height
				}, heightSpeed, function() {
					$elm.opacity(1, fadeSpeed, callback);
				});
				
			});
			
		};
		
	})(jQuery);	
	
	
	// ----------------------------------------------------------------------------------------
	// animate hide
	
	
	(function($) {
	
		$.fn.animateHide = function(fadeSpeed, heightSpeed, remove, callback){
			
			return this.each(function() {
			
				var $elm = $(this),
					height = $elm.height();
				
				$elm.opacity(0, fadeSpeed, function() {
					$elm.animate({
						height: 0
					}, heightSpeed, function() {
						$elm.height(height);
						if (remove) $elm.remove();
						if ($.isFunction(callback)) callback();
					});
				});
				
			});
			
		};
		
	})(jQuery);	
	
	
	// ----------------------------------------------------------------------------------------
	// Filter Data
	
	
	(function($) {
	
		$.fn.filterData = function(data, value){
			
			return $(this).filter(':[data-' + data + ' = "' + value + '"]');
			
		};
		
	})(jQuery);	
	
	
	// ----------------------------------------------------------------------------------------
	// Remove on click outside
	
	
	(function($) {
	
		$.fn.removeClickOutside = function(callback){
			
			var $elm = $(this);
			
			$(document).on('click.removeElm', function(e) {
				$target = $(e.target);
				if ($target.is($elm) || $elm.has($target).is($elm)) return;									
				$(document).off('click.removeElm');
				if ($.isFunction(callback)) callback($elm);
			});
			
			return this;
			
		};
		
	})(jQuery);	
	
	
	// ----------------------------------------------------------------------------------------
	// scroll
	
	
	(function($) {
	
		$.fn.startScroll = function(callback){
			
			var $elm = $(this);			
			if (!$elm.data('jsp')) $elm.on('jsp-initialised', function(event, isScrollable) {
				
				$parent = $elm.parent();
				if (isScrollable) $parent.addClass('is-scrollable');
				else $parent.removeClass('is-scrollable');
				
			}).jScrollPane({autoReinitialise: true});		
			return this;
			
		};
		
	})(jQuery);	
	
	
	// ----------------------------------------------------------------------------------------
	// center images
	
	
	(function($) {
	
		$.fn.centerImg = function() {	
			
			return this.each(function() {
			
				var	$box = $(this),
					$img = $box.find('img'),					
					boxHeight = $box.height(),
					boxWidth = $box.width(),
					imgHeight = $img.height(),
					imgWidth = $img.width();
					newWidth = boxWidth,
					newHeight = (imgHeight * boxWidth) / imgWidth;
				
					/*$img.css({
						width: newWidth,
						height: newHeight,
						marginLeft: -(newWidth - boxWidth) / 2,
						marginTop: -(newHeight - boxHeight) / 2
					});*/
					
					if (newHeight <= boxHeight) $img.css({ width: 'auto', height: boxHeight, marginLeft: -(((imgWidth * boxHeight) / imgHeight) - boxWidth) / 2 });
					else $img.css({ width: boxWidth, height: 'auto', marginTop: -(newHeight - boxHeight) / 2});
				
			});
			
		};
		
	})(jQuery);
	